﻿;*********************************************************************************************
; Dateiname 	: 	SD_Browserfarben.lsp
; Autor         : 	wz
; Erstellt      :	2015
; geändert      :   21.06.2021 >> angepasster Code von Andy Poulsen >> Pseudoordner haben jetzt auch die Farbe der Kindelemente!
;*********************************************************************************************
; Beschreibung  :		- 	Setzt Browserfarben in Abhängigkeit vom Status in Phoenix/PDM
;					-	
;*********************************************************************************************
; Änderungen
;
;*********************************************************************************************
; --------------------------------------------------------------------------------------------
; (Display (format nil "Name~20T: Stephan")   ~20T >> Setzt Cursor in Spalte 20!!
; (Display (format nil "Name~%: Stephan")     ~%   >> Erzeugt Zeilenumbruch!!!!!!
; --------------------------------------------------------------------------------------------

#|
Verbesserte Version von Andy Poulsen AI MAXTools, Inc.

I rewrote your code without using the sd-defdialog, which isn't required for something like this. 
Instead, you can just call a function to turn colors on or off (or toggle on/off).

The code below has the pseudo-folders inheriting the color of their children. 
If you want them to be a different color, uncomment the line that matches the pseudo-folder check.

I have added a few comments to describe what the code is doing.  Please let me know if you have any questions.
|#


(in-package  :teo) 
(use-package :oli)
(use-package :SCHILLER)

(display "SD_Browserfarben.lsp > NEUE VERSION wurde für Admin geladen!!")

(defvar *ColorState* nil) ;; defvar erzeugt eine globale Variable die "*" sind nur da damit man diese erkennt. Nicht Pflicht!

(defun browser-colors-on ()
  (setq *ColorState* t)
  (defun my-color-interrogator (node obj-name)
    (declare (ignore obj-name))
    (let (myobj myattrib children)
      (setf myobj (sd-pathname-to-obj (browsernode-objpath node)))
      (when (and myobj
                (or (sd-inq-part-p myobj)
                    (sd-inq-assembly-p myobj)))
        ;; if the object is a pseudo-folder, use its first child object as "myobj"
        (when (sd-is-pseudo-folder-node-p (browsernode-nodeid node))
          (setq children (sd-query-browser "parcel-gbrowser" :get-children node)) ;;"parcel-gbrowser" ist der Name der Strukturliste!!
          (setq myobj (sd-pathname-to-obj (browsernode-objpath (first children)))))
        ;; capture the attribute value so we don't have to retrieve it multiple times when testing (faster!)
        (setf myattrib (sd-inq-item-attribute myobj "PDM-ATTR" :status :attachment :contents))
        (cond
         ((sd-string= myattrib "In Arbeit") 	"#0000ff" ) 	;; blau 
         ((sd-string= myattrib "Zur Pruefung") 	"#FF00FF" ) 	;: Magenta 
         ((sd-string= myattrib "Vorfreigabe") 	"#FF8000" ) 	;: orange
         ((sd-string= myattrib "Freigabe") 		"#008000" ) 	;: green
         ((sd-string= myattrib "Gesperrt") 		"#FF0000" ) 	;: rot
         ;; uncomment the following line to highlight pseudo-folders separately (red in this case)
         ;;((sd-is-pseudo-folder-node-p (browsernode-nodeid node)) "#FF0000")
         ((sd-inq-part-p myobj) 								"#414141") 			;; highlight parts w/o matching attrib in blue
         ((sd-inq-assembly-p myobj) 						"#414141") 	;; highlight assemblies w/o matching attrib in green
         (t "#000000")  ;; if nothing above matches
        ))
    ))
  (sd-browser-exec-cmd "parcel-gbrowser" :REFRESH-TREE)
);;defun

(defun browser-colors-off ()
  (setq *ColorState* nil)
  (defun my-color-interrogator (node obj-name)
    (declare (ignore obj-name))
    "#000000")
  (sd-browser-exec-cmd "parcel-gbrowser" :REFRESH-TREE)
  );;defun

(defun browser-colors-toggle ()
  (if *ColorState*
      (browser-colors-off)
			(browser-colors-on))
);;defun

(if *ColorState*
    (browser-colors-on)
		(browser-colors-off))
    
;; HINWEIS: Wir müssen die Abfrage (Interrogator) nur einmal hinzufügen, also definieren wir eine Variable um zu überprüfen ob diese hinzugefügt wurde.

(defvar *colorStateInterrogatorAdded* nil)

(unless *colorStateInterrogatorAdded*
  (sd-browser-add-interrogator "parcel-gbrowser"
    :interrogator-type :text-color 
    :interrogator-func 'my-color-interrogator)
  (setq *colorStateInterrogatorAdded* t)
);;unless
	
