﻿;*********************************************************************************************
;*********************************************************************************************
; Dateiname     :     SD_SchillerTools.lsp
; Autor         :     Stephan Wörz
; Erstellt      :     22.11.2012
; geändert      :
;*********************************************************************************************
; Beschreibung    :   Bereitstellen des Menu "Schillertools" & laden der Tools für V18.xx
;                     >>   Befehle müssen in der sd_avail_cmds.cmd definiert werden
;
;*********************************************************************************************
; --------------------------------------------------------------------------------------------
; ä Ì       Ä Ø    ö Î    Ö Ú    ü Ï    Ü Û    ß Þ    ° ³     µ ó
; (Display (format nil "Name~20T: Stephan")   ~20T >> Setzt Cursor in Spalte 20!!
; (Display (format nil "Name~%: Stephan")     ~%   >> Erzeugt Zeilenumbruch!!!!!!
; --------------------------------------------------------------------------------------------
; BASIC FUNCTIONS: --> "BasicTools.lsp"
; SD_CheckWorkplane     Parameter:  Keine               - prüft ob Arbeitsebene vorhanden
; --------------------------------------------------------------------------------------------
; Befehl für Toolbars erzeugen
; (sd-define-available-command  "SolidDesigner"
;                               "SCHILLER"
;                               "Lochkreis"
;                               :ui-behavior :default  ;UI Verhalten :relative :none
;                               :image ( Format NIL "~A/SD_Lochkreis.bmp" (MEI::GETENV "SCHILLERICONDIR"))
;                               :action '(OLI::SD-CALL-DIALOG "SD_Lochkreis")
;);;sd-define-available-command
; --------------------------------------------------------------------------------------------


;(sd-hide-console-window)
;(sd-show-console-window)
;(setf si::*enter-break-handler* t)


    (in-package      :SCHILLER)
    (use-package     :OLI)
    (use-package     :MEI)


; ========================= Wer sieht das Adminmenu ============================================================
(defun GiveAdminRights ()
  (LET (Result UserList HostList CurrentUser CurrentHost)
    (SETQ
      Result 	    nil
      CurrentUser  (sd-string-upcase (SYSTEM::GETENV "USERNAME"))
      CurrentHost  (sd-string-upcase (SYSTEM::GETENV "COMPUTERNAME"))
      UserList    '("SWOERZ"  ) ;;"TIMO.DIETTER"
      HostList    '("")
    )
    (IF (OR
          (MEMBER CurrentUser UserList :TEST 'EQUAL)
          (MEMBER CurrentHost HostList :TEST 'EQUAL)
        )
      (SETQ Result T)
    )
    Result
  );;LET
);;defun

;; Die Variable SCHILLERMACRODIR wird in der ccmstart.bat gesetzt!
;; Die Variable SCHILLERICONDIR wird in der ccmstart.bat gesetzt!

; ========================= G O O D I E S   M I T L A D E N ===========================================================

; ========================= N I C H T  I M  M E N U E =================================================================
 (load (format nil "~a/01_BasicTools.lsp"                                 (MEI::GETENV "SCHILLERMACRODIR")))        ;stellt Grundlegende Funktionen zur Verfügung
 (load (format nil "~a/SD_SetPartProperties.lsp"                          (MEI::GETENV "SCHILLERMACRODIR")))        ;lädt Makros zum Ändern/Setzen von div. Teileigenschaften 
 (load (format nil "~a/SD_Schiller_Browserviews.lsp"                      (MEI::GETENV "SCHILLERMACRODIR")))        ;erzeugt zusätzliche Browserviews
 (load (format nil "~a/SD_StoerkonturOnOFF.lsp"                           (MEI::GETENV "SCHILLERMACRODIR")))        ;lädt Makro
 (load (format nil "~a/SD_ContainerOnOFF.lsp"                             (MEI::GETENV "SCHILLERMACRODIR")))        ;lädt Makro
 (load (format nil "~a/SD_ContainerInAssyOnOFF.lsp"                       (MEI::GETENV "SCHILLERMACRODIR")))        ;lädt Makro
 (load (format nil "~a/SD_PanesOnOFF.lsp"                       		  (MEI::GETENV "SCHILLERMACRODIR")))        ;lädt Makro
 (load (format nil "~a/SD_Browserfarben_PX.lsp"                           (MEI::GETENV "SCHILLERMACRODIR")))        ;färbt Objekte in der Strukturliste entsprechend Ihrem DB-Status
 (load (format nil "~a/SD_Browserfarben.lsp"                              (MEI::GETENV "SCHILLERMACRODIR")))        ;färbt Objekte in der Strukturliste entsprechend Ihrem DB-Status - Version von Andy Poulsen AI MAXTools
 (load (format nil "~a/SD_SWAPFACECOLOR.lsp"                              (MEI::GETENV "SCHILLERMACRODIR")))        ;ersetzt eine gewählte Flächenfarbe durch eine andere 
 (load (format nil "~a/SD_Flaechenfarben.lsp"                             (MEI::GETENV "SCHILLERMACRODIR")))        ;Befehle zum schnellen ändern von Flächeneigenschaften
 (load (format nil "~a/SD_ExactBox_PartDimensions.lsp"                    (MEI::GETENV "SCHILLERMACRODIR")))        ;Gibt die Hauptabmessungen eines Teils aus
 (load (format nil "~a/SD_2dgeoMultipleCopies.lsp"						  (MEI::GETENV "SCHILLERMACRODIR")))		;ermöglicht das einfache Mehrfach-kopieren von 2D-Elementen
 (load (format nil "~a/SD_CreatePaintedPart.lsp"						  (MEI::GETENV "SCHILLERMACRODIR")))		;erstellt eine skalierte Kopie eines gewählten Teils zum abbilden von Sonderlackierungen
 (load (format nil "~a/SD_3D-PDF_erzeugen.lsp"							  (MEI::GETENV "SCHILLERMACRODIR")))		;zieht Lizenz, erzeugt PDF, gibt Lizenz wieder frei
 (load (format nil "~a/SD_UpdateThreadColor.lsp"                          (MEI::GETENV "SCHILLERMACRODIR")))        ;färbt alle alten (rosa) Gewindeflächen blau
 ; ========================= T A B E L L E N ========================================================================== 
 
;;  (load (format nil "~a/SD_SCHILLER_Atribute_Tabellen.lsp"                (MEI::GETENV "SCHILLERMACRODIR")))       ;stellt die Tabellen für "Externe_Attribute" zur Verfügung

; ========================= S C  A D M I N T O O L S =================================================================
(IF (GiveAdminRights) ;;nur laden für bestimmte Benutzer
 (progn  
   (load (format nil "~a/SD_Browserfarben_New.lsp"                          (MEI::GETENV "SCHILLERMACRODIR")))      ;färbt Objekte in der Strukturliste entsprechend Ihrem DB-Status >> neue Version!! PseudoOrdner in richtiger Farbe!
	 (load (format nil "~a/Call_SD_Test.lsp"                                  (MEI::GETENV "SCHILLERMACRODIR")))    ;lädt Testbaustein 1 / 2 / 3 / 4 / 5
   (load (format nil "~a/SD_GetColorValues.lsp"                             (MEI::GETENV "SCHILLERMACRODIR")))        ;lädt Admin-Tool zum ausgeben der Farbwerte
   (load (format nil "~a/SD_Teileigenschaften.lsp"                          (MEI::GETENV "SCHILLERMACRODIR")))        ;gibt Teileeigenschaften aus
   ;;(load (format nil "~a/SD_UpdateThreadColor.lsp"                          (MEI::GETENV "SCHILLERMACRODIR")))        ;färbt alle alten (rosa) Gewindeflächen blau
   (load (format nil "~a/SD_RenderWhite.lsp"                                (MEI::GETENV "SCHILLERMACRODIR")))        ;setzt die Eigenschaften des aktuellen Fensters auf weiss & Renderlicht
   (load (format nil "~a/KeyShot/SD_PrepareForRendering.lsp"                (MEI::GETENV "SCHILLERMACRODIR")))        ;Umbenennen der Objekte in Abhängigkeit von Attributen
  ;; (load (format nil "~a/Keyshot/SD_PrepareForKeyshot.lsp"                (MEI::GETENV "SCHILLERMACRODIR")))        ;Aufarbeiten der Baugruppe um KeyShot zu unterstützen
  );;progn
);;IF
 

;===========  Materialvorgaben ==================================================================
 (load (format nil "~a/SD_Absolute_Masse.lsp"                             (MEI::GETENV "SCHILLERMACRODIR")))        ;weist Teil/Bgr. eine Zielmasse zu
 (load (format nil "~a/SD_Teilematerial.lsp"                              (MEI::GETENV "SCHILLERMACRODIR")))        ;zuweisen von Materialeigenschaften (Dichte & Farbe) 
 (load (format nil "~a/SD_DB_Teileigenschaften.lsp"                       (MEI::GETENV "SCHILLERMACRODIR")))        ;zum setzen der Teileigenschaften in Abhängigkeit der Datenbankeinträge

;===========  Kommunikation =====================================================================
 (load (format nil "~a/SD_Bearbeitungsnotiz.lsp"                          (MEI::GETENV "SCHILLERMACRODIR")))        ;anfügen von Beschriftungen an Kanten, Flächen und Teile
;;       (load (format nil "~a/SD_SCHILLER_Atribute.lsp"                          (MEI::GETENV "SCHILLERMACRODIR")))       
 (load (format nil "~a/SD_Update_PX_Attribute.lsp"                        (MEI::GETENV "SCHILLERMACRODIR")))        ;Phoenix erforderlich: Attribute aller Teile einer Baugruppe aktualisieren
 (load (format nil "~a/SD_ReserveRecursive.lsp"                           (MEI::GETENV "SCHILLERMACRODIR")))        ;Phoenix erforderlich: alle Teile einer Baugruppe reservieren
 (load (format nil "~a/SD-Koordinatenabstand_2er_Punkte.lsp"              (MEI::GETENV "SCHILLERMACRODIR")))        ;Ausgabe der Koordinaten eines 3D-Punktes relativ zu einem zu wählenden Ursprung

;===========  Teil-BaugruppenTools ==============================================================

 (load (format nil "~a/SD_Move.lsp"                                       (MEI::GETENV "SCHILLERMACRODIR")))
 (load (format nil "~a/SD_Teile_nach_Benennung_loeschen.lsp"              (MEI::GETENV "SCHILLERMACRODIR")))
 (load (format nil "~a/SD_Exemplar.lsp"                                   (MEI::GETENV "SCHILLERMACRODIR")))
 (load (format nil "~a/SD_Teile_und_Baugruppen_ersetzen.lsp"              (MEI::GETENV "SCHILLERMACRODIR")))
 (load (format nil "~a/SD_Duplicate.lsp"                                  (MEI::GETENV "SCHILLERMACRODIR")))
 (load (format nil "~a/Sd_MoveToOrigin.lsp"                               (MEI::GETENV "SCHILLERMACRODIR")))
 (load (format nil "~a/SD_InqFaceNormal.lsp"                              (MEI::GETENV "SCHILLERMACRODIR")))
 (load (format nil "~a/SD_Rename_Assy.lsp"                                (MEI::GETENV "SCHILLERMACRODIR")))
 (load (format nil "~a/SD_CreateCollissionAnalysis.lsp" 				  (MEI::GETENV "SCHILLERMACRODIR")))
 (load (format nil "~a/SD_CreateConfigs.lsp" 							  (MEI::GETENV "SCHILLERMACRODIR")))
 (load (format nil "~a/SD_SelektivEigenWeg.lsp" 						  (MEI::GETENV "SCHILLERMACRODIR")))

;=========== Bearbeitungstools ===================================================================
 (load (format nil "~a/SD_StretchOnEdge.lsp"                              (MEI::GETENV "SCHILLERMACRODIR")))
 (load (format nil "~a/SD_gleiche_Kanten_verrunden.lsp"                   (MEI::GETENV "SCHILLERMACRODIR")))
 (load (format nil "~a/SD_Aussengewinde.lsp"                              (MEI::GETENV "SCHILLERMACRODIR")))
 (load (format nil "~a/SD_Bolzengewinde.lsp"                              (MEI::GETENV "SCHILLERMACRODIR")))
 (load (format nil "~a/SD_Gewindefreistich.lsp"                           (MEI::GETENV "SCHILLERMACRODIR")))
 (load (format nil "~a/SD_Schleiffreistich.lsp"                           (MEI::GETENV "SCHILLERMACRODIR")))
 (load (format nil "~a/SD_VerschiedeneWellenfreistiche.lsp"               (MEI::GETENV "SCHILLERMACRODIR")))
 (load (format nil "~a/SD_EINSTICH_471.lsp"                               (MEI::GETENV "SCHILLERMACRODIR")))
 (load (format nil "~a/SD_MultipleShares.lsp"                             (MEI::GETENV "SCHILLERMACRODIR")))
 (load (format nil "~a/SD_ChangeDiameter.lsp"                             (MEI::GETENV "SCHILLERMACRODIR")))
 (load (format nil "~a/SD_Rotate3Axis.lsp"                            	  (MEI::GETENV "SCHILLERMACRODIR")))        ;Rotiert Teil um den Schwerpunkt in 3 Achsen (...zum Ausrichten/Positionieren bei Minimalabweichung
 (load (format nil "~a/SD_EngraveText.lsp"                                (MEI::GETENV "SCHILLERMACRODIR")))        ;lädt Makro
 (load (format nil "~a/SD_CenterSlot.lsp"                                 (MEI::GETENV "SCHILLERMACRODIR")))        ;lädt Makro

;=========== Geometrietools ================================================================
;;      (load (format nil "~a/SD_Sechskant.lsp"                                  (MEI::GETENV "SCHILLERMACRODIR")))
 (load (format nil "~a/SD_AEinSchwerpunkt.lsp"                            (MEI::GETENV "SCHILLERMACRODIR")))
 (load (format nil "~a/SD_AE_FL_Schwerpkt.lsp"                            (MEI::GETENV "SCHILLERMACRODIR")))        ;lädt Makro SD_AE_FL_Schwerpkt.lsp
 (load (format nil "~a/SD_Querschnitt.lsp"                                (MEI::GETENV "SCHILLERMACRODIR")))
 (load (format nil "~a/SD_Konturlaenge.lsp"                               (MEI::GETENV "SCHILLERMACRODIR")))
 (load (format nil "~a/SD_Streckenteiler.lsp"                             (MEI::GETENV "SCHILLERMACRODIR")))
 (load (format nil "~a/SD_HGeoColor.lsp"                                  (MEI::GETENV "SCHILLERMACRODIR")))
 (load (format nil "~a/SD_RadialSlot.lsp"                                 (MEI::GETENV "SCHILLERMACRODIR")))
 (load (format nil "~a/SD_Lochkreis.lsp"                                  (MEI::GETENV "SCHILLERMACRODIR")))

;;=========== Fenstertools ================================================================
(load (format nil "~a/SD_Fenster.lsp"                                     (MEI::GETENV "SCHILLERMACRODIR")))
;;(load (format nil "~a/SD_Einpassen.lsp"                                   (MEI::GETENV "SCHILLERMACRODIR")))
(load (format nil "~a/SD_Hintergrund_weis.lsp"                            (MEI::GETENV "SCHILLERMACRODIR")))
(load (format nil "~a/SD_Hintergrund_schwarz.lsp"                         (MEI::GETENV "SCHILLERMACRODIR")))
(load (format nil "~a/SD_Hintergrund_VERLAUF.lsp"                         (MEI::GETENV "SCHILLERMACRODIR")))
(load (format nil "~a/SD_Hintergrund_VERLAUF_grau.lsp"                    (MEI::GETENV "SCHILLERMACRODIR")))
(load (format nil "~a/SD_RenderWhite.lsp"                                 (MEI::GETENV "SCHILLERMACRODIR")))
(load (format nil "~a/SD_Ansicht_begradigen.lsp"                          (MEI::GETENV "SCHILLERMACRODIR")))
(load (format nil "~a/SD_CreateThumbnails.lsp"                         	  (MEI::GETENV "SCHILLERMACRODIR")))
(load (format nil "~a/SD_ViewPort.lsp"                                    (MEI::GETENV "SCHILLERMACRODIR")))        ;Ansichten setzen, ViewPort-Eigenschaften auslesen



;;================================================================================================
;;=========== Ribbontab "S C H I L L E R T O O L S" erzeugen =====================================
;;================================================================================================

(sd-fluentui-add-ribbon-tab "Schillertools"
    :title "S C H I L L E R T O O L S"
    :position :end ; <number> (Zero based position within the ribbon. 0 corresponds to :beginning) | :beginning | :end | <string> (Name of a tab created with sd-fluentui-add-ribbon-tab. The new ribbon tab will be shown before this tab.)
    :appendUtilitiesGroup t
);;

;===============================================================================================
;=========== Ribbongruppe "Darstellungsfenster" erzeugen =======================================
;===============================================================================================
(sd-fluentui-add-ribbon-group "SC_Fenster"
  :parent "Schillertools"
  :title "DARSTELLUNGSFENSTER"
  :slot 1
  )

;================================================================
;=========== Ribbonbuttons "Darstellungsfenster" erzeugen =======
;================================================================
(sd-fluentui-add-ribbon-button
      :parent '("Schillertools" "SC_Fenster")
      :name "VP-Color"
      :splitButton t
        :image       (format nil "~a/SD_Verlauf.bmp"  (MEI::GETENV "SCHILLERICONDIR"))
      :largeImage t
      :label "VP-COLOR"
      :contents
      `(
         (:label "schwarz"
          :availCmd ("SolidDesigner" "SC_Fenster" "SD_Hintergrund_schwarz"))
         (:label "weis"
          :availCmd ("SolidDesigner" "SC_Fenster" "SD_Hintergrund_weis"))
         (:label "Blauverlauf"
          :availCmd ("SolidDesigner" "SC_Fenster" "SD_Hintergrund_Verlauf_blau"))
             (:label "Grauverlauf"
          :availCmd ("SolidDesigner" "SC_Fenster" "SD_Hintergrund_Verlauf_grau"))
             (:label "Rendern"
          :availCmd ("SolidDesigner" "SC_Fenster" "RenderWhite"))
        );;contents
    );;
(sd-fluentui-add-ribbon-separator
  :parent  '("Schillertools" "SC_Fenster")
  )
;;      (sd-fluentui-add-ribbon-button
;;        :parent '("Schillertools" "SC_Fenster")
;;        :availCmd '("SolidDesigner" "SC_Fenster" "FIT")
;;      );;
(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_Fenster")
  :availCmd '("SolidDesigner" "SC_Fenster" "ContainerOnOFF")
);;
(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_Fenster")
  :availCmd '("SolidDesigner" "SC_Fenster" "AnsichtGerade")
);;
(sd-fluentui-add-ribbon-separator
  :parent  '("Schillertools" "SC_Fenster")
  )


;;================================================================================================
;;=========== Ribbongruppe "Geometrietools" erzeugen =============================================
;;================================================================================================
(sd-fluentui-add-ribbon-group "SC_Geometrietools"
  :parent "Schillertools"
  :title "GEOMETRIETOOLS"
  :slot  2
  )

;================================================================
;;=========== Ribbonbuttons "Geometrietools" erzeugen ===========
;================================================================
;;      (sd-fluentui-add-ribbon-button
;;        :parent '("Schillertools" "SC_Geometrietools")
;;        :availCmd '("SolidDesigner" "SC_Geometrietools" "Sechskant")
;;      );;
(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_Geometrietools")
  :availCmd '("SolidDesigner" "SC_Geometrietools" "SD_Lochkreis")
);;
(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_Geometrietools")
  :availCmd '("SolidDesigner" "SC_Geometrietools" "SD_RadialSlot")
);;
			(sd-fluentui-add-ribbon-separator
			  :parent  '("Schillertools" "SC_Geometrietools")
			  )
(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_Geometrietools")
  :availCmd '("SolidDesigner" "SC_Geometrietools" "SD_AEinSchwerpunkt")
);;

(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_Geometrietools")
  :availCmd '("SolidDesigner" "SC_Geometrietools" "SD_AE_FL_Schwerpkt")
);;

(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_Geometrietools")
  :availCmd '("SolidDesigner" "SC_Geometrietools" "SD_Querschnitt")
);;
			(sd-fluentui-add-ribbon-separator
			  :parent  '("Schillertools" "SC_Geometrietools")
			  )
(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_Geometrietools")
  :availCmd '("SolidDesigner" "SC_Geometrietools" "SD_Konturlaenge")
);;
(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_Geometrietools")
  :availCmd '("SolidDesigner" "SC_Geometrietools" "SD_Mehrfachgeo")
);;



(sd-fluentui-add-ribbon-button
      :parent '("Schillertools" "SC_Geometrietools")
      :name "HGeoTools"
      :splitButton t
      ;:image       (format nil "~a/SD_Schiller_gruen.bmp" (MEI::GETENV "SCHILLERICONDIR"))
      :largeImage nil
      :label "...Mehr"
      :contents `(
                   (    :label "HGeo blau"
                       :availCmd ("SolidDesigner" "SC_Geometrietools" "HGeo_AllBlue"))
                   (    :label "HGeo Farbe"
                       :availCmd ("SolidDesigner" "SC_Geometrietools" "SD_HGeoColor"))
                   (    :label "Streckenteiler"
                       :availCmd ("SolidDesigner" "SC_Geometrietools" "SD_Streckenteiler"))

                   );;contents
    );;



;;================================================================================================
;;=========== Ribbongruppe "Teile bearbeiten" erzeugen ===========================================
;;================================================================================================
(sd-fluentui-add-ribbon-group "SC_TeileBearbeiten"
  :parent "Schillertools"
  :title "TEILE BEARBEITEN"
  :slot 3
  )

;================================================================
;;=========== Ribbonbuttons "Teile bearbeiten" erzeugen =========
;================================================================

(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_TeileBearbeiten")
  :availCmd '("SolidDesigner" "SC_TeileBearbeiten" "Notiz")
);;

(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_TeileBearbeiten")
  :availCmd '("SolidDesigner" "SC_TeileBearbeiten" "StretchOnEdge")
);;
(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_TeileBearbeiten")
  :availCmd '("SolidDesigner" "SC_TeileBearbeiten" "SD_gleiche_Kanten_verrunden")
);;
(sd-fluentui-add-ribbon-separator
  :parent  '("Schillertools" "SC_TeileBearbeiten")
)
(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_TeileBearbeiten")
  :availCmd '("SolidDesigner" "SC_Formelemente" "SD_Aussengewinde")
);;
(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_TeileBearbeiten")
  :availCmd '("SolidDesigner" "SC_Formelemente" "SD_Bolzengewinde")
);;

(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_TeileBearbeiten")
  :availCmd '("SolidDesigner" "SC_Formelemente" "SD_ChangeDiameter")
);;


(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_TeileBearbeiten")
  :availCmd '("SolidDesigner" "SC_TeileBearbeiten" "SD_EngraveText")
);;

(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_TeileBearbeiten")
  :availCmd '("SolidDesigner" "SC_TeileBearbeiten" "SD_CenterSlot")
);;

(sd-fluentui-add-ribbon-separator
  :parent  '("Schillertools" "SC_TeileBearbeiten")
)

(sd-fluentui-add-ribbon-button
      :parent '("Schillertools" "SC_TeileBearbeiten")
      :name "Einstiche"
      :splitButton t
        :image       (format nil "~a/SD_Schiller_gruen.bmp" (MEI::GETENV "SCHILLERICONDIR"))
      :largeImage nil
      :label "Einstiche"
      :contents `(
                                (    :label "Gewindefreistich"
                                    :availCmd ("SolidDesigner" "SC_Formelemente" "SD_Gewindefreistich"))
                                (    :label "Schleiffreistich"
                                    :availCmd ("SolidDesigner" "SC_Formelemente" "SD_Schleiffreistich"))
                                (    :label "Sicherungsringnut DIN 471 (Welle)"
                                    :availCmd ("SolidDesigner" "SC_Formelemente" "SD_EINSTICH_471"))
                                (    :label "verschiedene Freistiche"
                                    :availCmd ("SolidDesigner" "SC_Formelemente" "SD_VerschiedeneWellenfreistiche"))
                                );;contents
    );;

(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_TeileBearbeiten")
  :availCmd '("SolidDesigner" "SC_Formelemente" "SD_MultipleShares")
);;

;;================================================================================================
;;=========== Ribbongruppe "Teileigenschaften" erzeugen ==========================================
;;================================================================================================
(sd-fluentui-add-ribbon-group "SC_Teileeigenschaften"
  :parent "Schillertools"
  :title "EIGENSCHAFTEN SETZEN / ÄNDERN"
  :slot 4
  )

;================================================================
;;=========== Ribbonbuttons "Teileigenschaften" erzeugen ========
;================================================================

(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_Teileeigenschaften")
  :availCmd '("SolidDesigner" "SC_Teileeigenschaften" "Masse")
);;
(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_Teileeigenschaften")
  :availCmd '("SolidDesigner" "SC_Teileeigenschaften" "Material")
);;
(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_Teileeigenschaften")
  :availCmd '("SolidDesigner" "SC_Teileeigenschaften" "DB-PartProps")
);;
 (sd-fluentui-add-ribbon-separator
   :parent  '("Schillertools" "SC_Teileeigenschaften")
 );;
 (sd-fluentui-add-ribbon-button
   :parent '("Schillertools" "SC_Teileeigenschaften")
   :availCmd '("SolidDesigner" "SC_Teileeigenschaften" "SD_SetPartProp_Alu")
 );;
 (sd-fluentui-add-ribbon-button
   :parent '("Schillertools" "SC_Teileeigenschaften")
   :availCmd '("SolidDesigner" "SC_Teileeigenschaften" "SD_SetPartProp_Baustahl")
 );;
 (sd-fluentui-add-ribbon-button
   :parent '("Schillertools" "SC_Teileeigenschaften")
   :availCmd '("SolidDesigner" "SC_Teileeigenschaften" "SD_SetPartProp_Edelstahl")
 );;

 (sd-fluentui-add-ribbon-separator
   :parent  '("Schillertools" "SC_Teileeigenschaften")
 );;

 (sd-fluentui-add-ribbon-button
   :parent '("Schillertools" "SC_Teileeigenschaften")
   :availCmd '("SolidDesigner" "SC_Teileeigenschaften" "SD_SetPartProp_E-Chain")
 );;
 (sd-fluentui-add-ribbon-button
   :parent '("Schillertools" "SC_Teileeigenschaften")
   :availCmd '("SolidDesigner" "SC_Teileeigenschaften" "SD_SetPartProp_Plastic")
 );;
 (sd-fluentui-add-ribbon-button
   :parent '("Schillertools" "SC_Teileeigenschaften")
   :availCmd '("SolidDesigner" "SC_Teileeigenschaften" "SD_SetPartProp_PC")
 );;

;;================================================================================================
;;=========== Ribbongruppe "Baugruppen bearbeiten" erzeugen ======================================
;;================================================================================================
(sd-fluentui-add-ribbon-group "SC_BgrBearbeiten"
  :parent "Schillertools"
  :title "BAUGRUPPEN BEARBEITEN"
  :slot 5
  )

;================================================================
;;=========== Ribbonbuttons "Baugruppen bearbeiten" erzeugen ====
;================================================================

(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_BgrBearbeiten")
  :availCmd '("SolidDesigner" "SC_BgrBearbeiten" "Move_NT")
);;
(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_BgrBearbeiten")
  :availCmd '("SolidDesigner" "SC_BgrBearbeiten" "Loesche_Auswahl")
);;
(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_BgrBearbeiten")
  :availCmd '("SolidDesigner" "SC_BgrBearbeiten" "Tauschen")
);;
(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_BgrBearbeiten")
  :availCmd '("SolidDesigner" "SC_BgrBearbeiten" "Duplicate")
);;
(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_BgrBearbeiten")
  :availCmd '("SolidDesigner" "SC_BgrBearbeiten" "RenameAssy")
);;
(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_BgrBearbeiten")
  :availCmd '("SolidDesigner" "SC_BgrBearbeiten" "SD_Kollissionsanalyse")
);;
(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_BgrBearbeiten")
  :availCmd '("SolidDesigner" "SC_BgrBearbeiten" "SD_SelektivEigenWeg")
);;

(sd-fluentui-add-ribbon-button
      :parent '("Schillertools" "SC_BgrBearbeiten")
      :name "ConfigTools"
      :splitButton t
      :largeImage nil
      :label "...KONFIG"
      :contents `(
                   (    :label "erstelle Konfig für ET-Ansichten"
                       :availCmd ("SolidDesigner" "SC_BgrBearbeiten" "SD_CreateConfig"))
                   );;contents
    );;



;;================================================================================================
;;=========== Ribbongruppe "Phoenix" erzeugen ====================================================
;;================================================================================================
(sd-fluentui-add-ribbon-group "SC_Phoenix"
  :parent "Schillertools"
  :title "ATTRIBUTE / PDM"
  :slot 6
  )

;================================================================
;;=========== Ribbonbuttons "Phoenix" erzeugen ==================
;================================================================

;;      (sd-fluentui-add-ribbon-button
;;        :parent '("Schillertools" "SC_Phoenix")
;;        :availCmd '("SolidDesigner" "SC_Phoenix" "ShowAttributes")
;;      );;
(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_Phoenix")
  :availCmd '("SolidDesigner" "SC_Phoenix" "UpdateAttributes")
);;
 (sd-fluentui-add-ribbon-button
   :parent '("Schillertools" "SC_Phoenix")
   :availCmd '("SolidDesigner" "SC_Phoenix" "Reserve")
 );;

;;================================================================================================
;;=========== Ribbongruppe "Verschiedene" erzeugen ===============================================
;;================================================================================================
(sd-fluentui-add-ribbon-group "SC_Verschiedene"
  :parent "Schillertools"
  :title "VERSCHIEDENE"
  :slot 7
  )

;================================================================
;;=========== Ribbonbuttons "Verschiedene" erzeugen =============
;================================================================

(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_Verschiedene")
  :availCmd '("SolidDesigner" "SC_Verschiedene" "Klicki")
);;

(sd-fluentui-add-ribbon-button
  :parent '("Schillertools" "SC_Verschiedene")
  :availCmd '("SolidDesigner" "SC_TeileBearbeiten" "ZumNullpunkt")
);;


(sd-fluentui-add-ribbon-button
      :parent '("Schillertools" "SC_Verschiedene")
      :name "MiscTools"
      :splitButton t
      :largeImage nil
      :label "...Mehr"
      :contents `(
                    (    :label "prüfe Flächenrichtungen"
                         :availCmd ("SolidDesigner" "SC_Teileeigenschaften" "Check3DVector"))
                    (    :label "Rotiere Teil um 3 Achsen"
                         :availCmd ("SolidDesigner" "SC_TeileBearbeiten" "SD_Rotate3Axis"))
                    (    :label "Ausgabe der Koordinaten eines 3D-Punktes relativ zu einem zu wählenden Ursprung"
                         :availCmd ("SolidDesigner" "SC_TeileBearbeiten" "Punktkoordinaten"))
                    (    :label "erzeuge JPGs der Hauptansichten"
                         :availCmd ("SolidDesigner" "SC_Verschiedene" "CreateThumbnails"))
                   );;contents
    );;


;; (sd-fluentui-add-ribbon-button
;;   :parent '("Schillertools" "SC_Verschiedene")
;;   :availCmd '("SolidDesigner" "SC_Verschiedene" "PrintTool")
;; );;






;;================================================================================================
;;=========== Ribbontab "A D M I N T O O L S" erzeugen ===========================================
;;================================================================================================

(IF (GiveAdminRights)

 (progn

   (sd-fluentui-add-ribbon-tab "Admintools"
       :title "ADMINTOOLS"
       :position :end ; <number> (Zero based position within the ribbon. 0 corresponds to :beginning) | :beginning | :end | <string> (Name of a tab created with sd-fluentui-add-ribbon-tab. The new ribbon tab will be shown before this tab.)
       :appendUtilitiesGroup nil
   );;

   ;===============================================================================================
   ;=========== Ribbongruppe "Abfragen" erzeugen ==================================================
   ;===============================================================================================
   (sd-fluentui-add-ribbon-group "SC_AdminInfo"
     :parent "Admintools"
     :title "ABFRAGEN"
       :slot 1
     )

   ;================================================================
   ;=========== Ribbonbuttons "Abfragen" erzeugen ==================
   ;================================================================

   (sd-fluentui-add-ribbon-button
     :parent '("Admintools" "SC_AdminInfo")
     :availCmd '("SolidDesigner" "SC_Admintools" "Teileeigenschaften")
   );;
  (sd-fluentui-add-ribbon-button
     :parent '("Admintools" "SC_AdminInfo")
     :availCmd '("SolidDesigner" "SC_Admintools" "GetColorValues")
   );;  
   
   ;===============================================================================================
   ;=========== Ribbongruppe "FENSTER" erzeugen ==================================================
   ;===============================================================================================
   (sd-fluentui-add-ribbon-group "SC_FENSTER"
     :parent "Admintools"
     :title "FENSTER"
       :slot 1
     )
   ;================================================================
   ;=========== Ribbonbuttons "FENSTER" erzeugen ==================
   ;================================================================

   (sd-fluentui-add-ribbon-button
     :parent '("Admintools" "SC_FENSTER")
     :availCmd '("SolidDesigner" "SC_Admintools" "RENDER_Fenster-weiss")
   );;
   (sd-fluentui-add-ribbon-button
     :parent '("Admintools" "SC_FENSTER")
     :availCmd '("SolidDesigner" "SC_Admintools" "PrepareForRendering")
   );;
   (sd-fluentui-add-ribbon-button
     :parent '("Admintools" "SC_FENSTER")
     :availCmd '("SolidDesigner" "SC_Admintools" "SetViewPort")
   );;

   ;===============================================================================================
   ;=========== Ribbongruppe "TESTCODE" erzeugen ==================================================
   ;===============================================================================================
   (sd-fluentui-add-ribbon-group "SC_AdminCode"
     :parent "Admintools"
     :title "TESTCODE"
       :slot 1
     )

   ;================================================================
   ;=========== Ribbonbuttons "TESTCODE" erzeugen ==================
   ;================================================================

   (sd-fluentui-add-ribbon-button
     :parent '("Admintools" "SC_AdminCode")
     :availCmd '("SolidDesigner" "SC_Admintools" "Call_SD_Test_1")
   );;
   (sd-fluentui-add-ribbon-button
     :parent '("Admintools" "SC_AdminCode")
     :availCmd '("SolidDesigner" "SC_Admintools" "Call_SD_Test_2")
   );;
   (sd-fluentui-add-ribbon-button
     :parent '("Admintools" "SC_AdminCode")
     :availCmd '("SolidDesigner" "SC_Admintools" "Call_SD_Test_3")
   );;
   (sd-fluentui-add-ribbon-button
     :parent '("Admintools" "SC_AdminCode")
     :availCmd '("SolidDesigner" "SC_Admintools" "Call_SD_Test_4")
   );;
   (sd-fluentui-add-ribbon-button
     :parent '("Admintools" "SC_AdminCode")
     :availCmd '("SolidDesigner" "SC_Admintools" "Call_SD_Test_5")
   );;

   ;===============================================================================================
   ;=========== Ribbongruppe "MODIFY" erzeugen ====================================================
   ;===============================================================================================
   (sd-fluentui-add-ribbon-group "SC_AdminModify"
     :parent "Admintools"
     :title "MODIFY"
       :slot 1
     )

   ;================================================================
   ;=========== Ribbonbuttons "MODIFY" erzeugen ==================
   ;================================================================

   (sd-fluentui-add-ribbon-button
     :parent '("Admintools" "SC_AdminModify")
     :availCmd '("SolidDesigner" "SC_Admintools" "UpdateThreadColor")
   );;

   ;===============================================================================================
   ;=========== Ribbongruppe "RECORD" erzeugen ====================================================
   ;===============================================================================================
   (sd-fluentui-add-ribbon-group "SC_AdminRecord"
     :parent "Admintools"
     :title "RECORD"
       :slot 1
     )

   ;================================================================
   ;=========== Ribbonbuttons "RECORD" erzeugen ==================
   ;================================================================

   (sd-fluentui-add-ribbon-button
     :parent '("Admintools" "SC_AdminRecord")
     :availCmd '("SolidDesigner" "SC_Admintools" "StartRecord")
   );;
   (sd-fluentui-add-ribbon-button
     :parent '("Admintools" "SC_AdminRecord")
     :availCmd '("SolidDesigner" "SC_Admintools" "StopRecord")
   );;

   ;===============================================================================================
   ;=========== Ribbongruppe "DOCU" erzeugen ====================================================
   ;===============================================================================================
   (sd-fluentui-add-ribbon-group "SC_AdminDocu"
     :parent "Admintools"
     :title "DOCU"
       :slot 1
     )

   ;================================================================
   ;=========== Ribbonbuttons "DOCU" erzeugen ==================
   ;================================================================

   (sd-fluentui-add-ribbon-button
     :parent '("Admintools" "SC_AdminDocu")
     :availCmd '("SolidDesigner" "SC_Admintools" "OnlineReference")
   );;


   ;===============================================================================================
   ;=========== Ribbongruppe "GOODIES" erzeugen ====================================================
   ;===============================================================================================
   (sd-fluentui-add-ribbon-group "SC_AdminGOODIES"
     :parent "Admintools"
     :title "GOODIES"
       :slot 1
     )

   ;================================================================
   ;=========== Ribbonbuttons "GOODIES" erzeugen ==================
   ;================================================================

   (sd-fluentui-add-ribbon-button
     :parent '("Admintools" "SC_AdminGOODIES")
     :availCmd '("SolidDesigner" "SC_Admintools" "Start_UnlockObj")
   );;
   (sd-fluentui-add-ribbon-button
     :parent '("Admintools" "SC_AdminGOODIES")
     :availCmd '("SolidDesigner" "SC_Admintools" "Start_dbdialog")
   );;
   (sd-fluentui-add-ribbon-button
     :parent '("Admintools" "SC_AdminGOODIES")
     :availCmd '("SolidDesigner" "SC_Admintools" "Remove3DLibInfo")
   );;



   ;===============================================================================================
   ;=========== Ribbongruppe "KEYSHOT" erzeugen ====================================================
   ;===============================================================================================
   (sd-fluentui-add-ribbon-group "SC_KEYSHOT"
     :parent "Admintools"
     :title "KEYSHOT"
       :slot 1
     )

   ;================================================================
   ;=========== Ribbonbuttons "KEYSHOT" erzeugen ===================
   ;================================================================

   ;;(sd-fluentui-add-ribbon-button
   ;;  :parent '("Admintools" "SC_KEYSHOT")
   ;;  :availCmd '("SolidDesigner" "SC_Teile" "KEYSHOT")
   ;;);;

   (sd-fluentui-add-ribbon-button
     :parent '("Admintools" "SC_KEYSHOT")
     :availCmd '("SolidDesigner" "SC_Teile" "PrepareForRendering")
   );;

 );;progn
);;If


